package org.jboss.btison.jbpm6.testbed.spring.rest.controller;

import org.jboss.btison.jbpm6.testbed.spring.domain.Order;
import org.jboss.btison.jbpm6.testbed.spring.event.CreateOrderEvent;
import org.jboss.btison.jbpm6.testbed.spring.event.OrderCreatedEvent;
import org.jboss.btison.jbpm6.testbed.spring.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
@RequestMapping("orders/create")
public class OrderController {
    
    @Autowired
    private OrderService orderService;
    
    @RequestMapping(method = RequestMethod.POST)
    public ResponseEntity<Order> createOrder(@RequestBody Order order) {
        
        OrderCreatedEvent orderCreated = orderService.createOrder(new CreateOrderEvent(order));
        
        Order response = orderCreated.getOrder();
        
        return new ResponseEntity<Order>(response, HttpStatus.CREATED);
        
    }

}
