package org.jboss.btison.jbpm6.testbed.spring.service;

import javax.inject.Inject;

import org.jboss.btison.jbpm6.testbed.spring.domain.Order;
import org.jboss.btison.jbpm6.testbed.spring.event.CreateOrderEvent;
import org.jboss.btison.jbpm6.testbed.spring.event.OrderCreatedEvent;
import org.springframework.stereotype.Service;

@Service
public class OrderServiceImpl implements OrderService {
    
    @Inject
    WorkflowHandlerService workflowHandlerService;

    @Override
    public OrderCreatedEvent createOrder(CreateOrderEvent event) {
        Order order = event.getOrder();
        Order response = new Order();
        long id = workflowHandlerService.startProcess("org.jboss.btison.jbpm.testbed.SimpleProcess", null);
        response.setOrderRef(order.getOrderRef());
        response.setStatus("Processed");
        response.setId(id);
        return new OrderCreatedEvent(response);
    }

}
