package org.jboss.btison.jbpm6.testbed.spring.service;

import java.util.Map;

import javax.inject.Inject;
import javax.inject.Named;

import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.internal.runtime.manager.context.EmptyContext;
import org.kie.internal.runtime.manager.context.ProcessInstanceIdContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

@Named("WorkflowHandlerService")
@Scope(BeanDefinition.SCOPE_SINGLETON)
@Service
public class WorkflowHandlerServiceImpl implements WorkflowHandlerService {
    
   // @//Inject
   // RuntimeManager runtimeManager;
    
    @Autowired
    ApplicationContext context;

    @Override
    public Long startProcess(String pId, Map<String, Object> parameters) {
        
        RuntimeEngine runtimeEngine = null;
        
    RuntimeManager runtimeManager =     (RuntimeManager) context.getBean("runtimeManager");
        try {
            runtimeEngine = runtimeManager.getRuntimeEngine(ProcessInstanceIdContext.get());
            KieSession ksession = runtimeEngine.getKieSession();
            ProcessInstance processInstance = ksession.startProcess(pId,parameters);
            return processInstance.getId();
        } finally {
            runtimeManager.disposeRuntimeEngine(runtimeEngine);
        }
    } 
}
